using Curses;

/* TODO: Cleanup all this spaguetti constuctor shit */

public enum DialogType {
	MESSAGE,
	ERROR,
	CHOOSE,
	ENTRY,
	YESNO,
}

public class Dialog : Panel {
	DialogType type;
	string msg;
	string input;

	/* TODO: like a panel */
	public Dialog (Canvas cv) {
		base (cv);
	}

	public Dialog.message (Canvas cv, string msg) {
		base (cv);
		this.msg = msg;
		this.type = DialogType.MESSAGE;
		this.title = "[Message]";
		this.line = 0;
	}

	public Dialog.entry (Canvas cv, string msg, string def) {
		base (cv);
		this.msg = msg;
		this.input = def;
		this.type = DialogType.ENTRY;
		this.title = "[Entry]";
		this.line = 2;
	}

	public Dialog.yesno (Canvas cv, string msg) {
		base (cv);
		this.msg = msg;
		this.type = DialogType.YESNO;
		this.title = "[YesNo]";
		this.line = 0;
	}

	public static string do_entry (Canvas cv, string msg, string def = "") {
		Dialog d = new Dialog.entry (cv, msg, def);
		cv.dialog = d;
		var ret = d.run ();
		cv.dialog = null;
		return ret;
	}

	public static bool do_message (Canvas cv, string msg) {
		Dialog d = new Dialog.message (cv, msg);
		cv.dialog = d;
		var ret = d.run ();
		cv.dialog = null;
		return (ret != null);
	}

	/* TODO: simplify the way the dialogs are created */
	public static bool do_yesno (Canvas cv, string msg) {
		Dialog d = new Dialog.yesno (cv, msg);
		cv.dialog = d;
		var ret = d.run ();
		cv.dialog = null;
		return (ret == "true");
	}

	public static string do_choose (Canvas cv, string msg, RenderDelegate rd) {
		Dialog d = new Dialog.choose (cv, msg, rd);
		cv.dialog = d;
		var ret = d.run ();
		cv.dialog = null;
		return ret;
	}

	public delegate string? RenderDelegate (int line);
	public RenderDelegate rd;

	public Dialog.choose (Canvas cv, string msg, RenderDelegate rd) {
		base (cv);
		this.msg = msg;
		this.type = DialogType.CHOOSE;
		this.title = "[Choose]";
		this.line = 3;
		this.rd = rd;
	}

	public string? run () {
		unowned List<Panel>? old = canvas.selected;
		canvas.selected = null;
		var cancel = false;
		var running = true;
		while(running) {
			canvas.do_refresh ();
			var ch = canvas.win.getch ();
			var donormal = true;
			switch (type) {
			case DialogType.ENTRY:
				switch (ch) {
				case 27:
					input = "";
					running = false;
					break;
				case '\n':
					running = false;
					break;
				case ConsKey.Backspace:
				case ConsKey.ControlH:
				case ConsKey.ControlH1:
					input = input.substring (0, (int)(input.size ()-1));
					break;
				default:
					input = "%s%c".printf (input, ch);
					break;
				}
				donormal = false;
				break;
			case DialogType.YESNO:
				switch (ch) {
				case 'y':
				case 'Y':
					line = 1;
					canvas.do_refresh ();
					Thread.usleep (200000);
					running = false;
					break;
				case 'n':
				case 'N':
					line = 2;
					canvas.do_refresh ();
					Thread.usleep (200000);
					running = false;
					break;
				}
				break;
			}
			if (donormal) {
				switch (ch) {
				case '=':
					scrolly = 0;
					break;
				case ConsKey.Down:
				case 'j':
					line++;
					break;
				case ConsKey.Up:
				case 'k':
					line--;
					break;
				case ConsKey.NextPage:
				case ConsKey.ControlF:
					line += 5;
					break;
				case ConsKey.PrevPage:
				case ConsKey.ControlB:
					line -= 5;
					break;
				case 'q': /* cancel */
					running = false;
					cancel = true;
					break;
				case '\n':
				case ' ':
					running = false;
					break;
				}
			}
		}

		canvas.dialog = null;
		canvas.selected = old;

		if (cancel)
			return "";

		switch (type) {
		case DialogType.YESNO:
			return (line==1)? "true": "false";
		case DialogType.CHOOSE:
			return rd (line-3+scrolly);
		case DialogType.ENTRY:
			return input;
		case DialogType.MESSAGE:
			return "";
		}
		return null;
	}

	public void align () {
		int h, w, y, x;

		w = (int)(msg.length+8);
		switch (type) {
		case DialogType.MESSAGE:
			h = 3;
			break;
		case DialogType.YESNO:
			h = 4;
			w += 6;
			break;
		case DialogType.ENTRY:
			h = 4;
			break;
		case DialogType.CHOOSE:
			h = 10; //LINES-4;
			break;
		default:
			h = 5;
			break;
		}
		y = (LINES-h-2)/2;
		x = (COLS-w)/2;
		if (x<0) x = 0;
		if (y<0) y = 0;
		move (h, w, y, x);
	}

	public override void render () {
		/* TODO: uncomment this? */
		//if (this.title != "")
			//this.title = "";
		render_begin ();
		switch (type) {
		case DialogType.MESSAGE:
			win.mvprintw (1, 4, msg);
			break;
		case DialogType.ENTRY:
			win.mvprintw (1, 4, msg);
			var str = input;
			int len = (int) input.len ();
			if (len > w-4) {
				int off = len-(w-4);
				str = input.substring (off, len-off);
			}
			win.mvprintw (2, 4, str);
			break;
		case DialogType.YESNO:
			win.mvprintw (1, 3, "Yes      %s".printf (msg));
			win.mvprintw (2, 3, "No");
			break;
		case DialogType.CHOOSE:
			win.mvprintw (1, 4, msg);
			for (int i = 0; i<5; i++) {
				int y = 3+i-scrolly;
				if (y<3)
					continue;
				var str = rd (i);
				if (str == null)
					break;
				win.mvprintw (y, 3, str);
			}
			break;
		}
		my_render_end ();
	}

	public void my_render_end () {
		//win.clrtobot ();
		if (border) {
			win.box (0, 0);
			win.mvprintw (0, 2, this.title);
		} else {
			win.mvprintw (0, 0, this.title);
		}
		win.mvprintw (line, 1, ">"); // %d".printf (scrolly));
		//win.redrawwin ();
		win.refresh ();
	}
}
