using Curses;

public class FilePanel : Panel {
	PtrArray lines;

	public FilePanel (Canvas cv, string path) {
		base (cv);
		this.title = "File: %s".printf (path);
		this.line = 1;
		lines = new PtrArray ();
		FileStream fs = FileStream.open (path, "r");

		char buf[1024];
		var str = fs.gets (buf);
		while (!fs.eof ()) {
			// TODO: detect long lines
			string *ptr = str.chomp ().dup ();
			lines.add (ptr);
			str = fs.gets (buf);
		}
	}

	~FilePanel () {
		/* TODO: free the array and its strings */
	}

	public override void render () {
		base.render_begin ();
		if (scrolly < 0)
			scrolly = 0;
		else
		if (scrolly > lines.len-h)
			scrolly = (int)lines.len-h;
		row = 1;
		for (int i=0; i<h-1; i++) {
			// TODO: control limits in a better way
			void * ptr = lines.pdata [i+scrolly]; //index (i);
			if (ptr != null) {
				unowned string str = (string)ptr;
				wline ("%04d  %s".printf (i+scrolly, str));
			}
		}
		base.render_end ();
	}
}
