using Curses;

public class HelpPanel : Panel {
	public HelpPanel (Canvas cv) {
		base (cv);
		this.title = "Help for keybindings";
	}

	public override void render () {
		if (scrolly<0)
			scrolly = 0;
		base.render_begin ();
		wline ("C+n      new panel");
		wline ("C+w      close panel");
		wline ("C+space  toggle monocle view for current column");
		wline ("space    activate row");
		wline (":        enter command");
		wline ("?        same as :help");
		wline ("hl       move cursor left or right");
		wline ("jk       same as down/up arrow keys");
		wline ("=        seek to line 0");
		wline ("[]       shift the column separator");
		wline ("C+hl     select left or right panel column");
		wline ("C+arrow  (control+left/right) same as above");
		wline ("HL       move a panel from one column to other");
		wline ("S+arrow  (shift+left/right) same as above");
		wline ("q        quit");
		wline ("");
		wline ("Mouse:");
		wline (" click   select panel");
		wline (" dblclck put current column in monocle mode");
		wline ("");
		wline ("Commands:");
		wline (" regs    display debugger registers");
		wline (" new     open empty panel");
		wline (" hex     hexadecimal view");
		wline (" motd    show message of the day");
		wline (" help    show this help");
		base.render_end ();
	}

	public new void activate () {
		
	}
}
