using Curses;

public class HexPanel : Panel {
	uint64 seek;

	public HexPanel (Canvas cv) {
		base (cv);
		this.title = "  offset     0 1  2 3  4 5  6 7  8 9  A B  C D  E F";
		this.seek = 0;
	}

	public override void render () {
		uint8[] b = new uint8[32];
		uint64 s = seek;
		if (scrolly<0) {
			// TODO: seek back
			s -= 16;
			scrolly = 0;
		}
		if (scrolly>h) {
			// TODO: seek forward
			scrolly = 0;
		}
		base.render_begin ();
		for (int i=2;i<h;i++) {
			wline ("0x%08llx %02x%02x %02x%02x %02x%02x %02x%02x %02x%02x %02x%02x %02x%02x %02x%02x".printf (
				s,
				b[0], b[1], b[2], b[3], b[4], b[5], b[6], b[7],
				b[8], b[9], b[10], b[11], b[12], b[13], b[14], b[15]
				));
			s += 16;
		}
		base.render_end ();
	}
}
